const MAXREOPENFILES = 5;
const FIRSTDYNAMICMENUITEM = 2;

function reopen() {


    var midMyPrefs      = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
    var savedFilesPrefs = midMyPrefs.getBranch("extensions.mid.lastusedsets.");
    var children        = savedFilesPrefs.getChildList("", {});

    var conv = Cc["@mozilla.org/intl/scriptableunicodeconverter"].
                   createInstance(Ci.nsIScriptableUnicodeConverter);
    conv.charset = "UTF-8"

    var menuitem;

    var popup = document.getElementById("mid:lastusedfilespopup");
    var popupMenuItems = popup.getElementsByTagName("menuitem");

    if ( children.length > 0 && popupMenuItems.length == 1 ) {
        var separator = document.createElement("menuseparator");
 	    popup.appendChild(separator);
    }

    var sortedLUFPrefs=children.sort();

    for (i = 0; i < children.length; i++ ){ 
	    if ( ! savedFilesPrefs.prefHasUserValue( sortedLUFPrefs[i] ) ) continue;

	    var file =  savedFilesPrefs.getComplexValue( sortedLUFPrefs[i], Ci.nsILocalFile);
	    try {
	      var menulabel=  conv.ConvertToUnicode(savedFilesPrefs.getCharPref(sortedLUFPrefs[i]));
	    } catch (e) { menulabel = savedFilesPrefs.getCharPref(sortedLUFPrefs[i]);
	    }
	    if (  popupMenuItems.length < FIRSTDYNAMICMENUITEM + i ) {   // existing menuitem?
               menuitem = document.createElement("menuitem");
               popup.appendChild(menuitem);
	    } else {
	      menuitem = popupMenuItems.item(i+1); 
	    }
	    menuitem.setAttribute("label", menulabel );
	    menuitem.setAttribute("oncommand",  "midRestoreSession(" + (i+1) +");");

    }

    return true;

}


function arrangeLUFPrefs(aLUF){

    var file = aLUF;
    var midMyPrefs      = Cc["@mozilla.org/preferences-service;1"].getService(Ci.nsIPrefService);
    var savedFilesPrefs = midMyPrefs.getBranch("extensions.mid.lastusedsets.");
    var children        = savedFilesPrefs.getChildList("", {});
    var sortedLUFPrefs  = children.sort(); // 
    var newChildren     = new Array;
    
    newChildren.push(file);

    for (i = 0; i < children.length; i++ ){
        if ( savedFilesPrefs.prefHasUserValue( sortedLUFPrefs[i] ) ) {
	    var nFile = savedFilesPrefs.getComplexValue( sortedLUFPrefs[i] , Ci.nsILocalFile );
	    if ( nFile.path != file.path ) newChildren.push(nFile);
	}
    }

    var limit = Math.min(MAXREOPENFILES, newChildren.length);

    for (i = 0; i < limit ; i++ ){
	    savedFilesPrefs.setComplexValue( i+1, Ci.nsILocalFile, newChildren[i] );
    }

    // TODO:more testing ...
    for (i = newChildren.length + 1 ; i < MAXREOPENFILES + 1 ; i++ ){
        if ( savedFilesPrefs.prefHasUserValue(i) ) {
	    savedFilesPrefs.clearUserPref(i);  }
    }

    return true;
}


